# Copyright (C) 2007 All right reserved by Shinya Kondo ( CGI KON )

	require "user.inc";

# 

	$CONF_FILE = "admin.conf";

	$KEYS_FILE = "admin.key";

	$DATA_FILE = "admin.tsv";

	$SOFT_NAME = qq!
		<A HREF="http://cgikon.com/share/infowork1/intro.html" TARGET="_blank">
			<FONT SIZE="2" COLOR="#FFFFFF"><B><I>CGIKON's ;</I></B></FONT>
		</A>
	!;

	$copywrite = qq!# Copyright (C) 2007 All right reserved by Shinya Kondo ( CGI KON )!;

	$SOFT_TITLE = qq!CGIKON's ;!;

	$PAGE_TITLE_0  = qq!ԥ!;
	$PAGE_TITLE_01 = qq!¹Ԥγǧ!;
	$PAGE_TITLE_02 = qq!顼!;
	$PAGE_TITLE_03 = qq!票顼!;
	$PAGE_TITLE_1  = qq!ԥ˥塼!;
	$PAGE_TITLE_21 = qq!!;
	$PAGE_TITLE_22 = qq!Ϸ!;
	$PAGE_TITLE_23 = qq!ɽ!;
	$PAGE_TITLE_24 = qq!ǡƤԽ!;
	$PAGE_TITLE_25 = qq!!;
	$PAGE_TITLE_2r = qq!ǡΰ!;

	@LIST_FIELD = ("Բ","ԤΤ","ʣ","ͥǡ","ɥ쥹","󥯥ɥ쥹");
	@LIST_LINES = ("","ʤ","","ȤΤ");
	@LIST_VFONT = ("","","","ɽʤ");
	@LIST_ORDER = ("","","߽");
	@LIST_VITEM = ("","̾α˥ǡ","̾β˥ǡ","̾ɽ");

# ׽

sub Set_Escape
{
	my($value) = @_;

	$value =~ s/\\/\\\\/g;
	$value =~ s/'/\\'/g;

	return $value;
}

# եλ֥å

sub Check_Time
{
	my($m_time) = @_;

	my($fsec,@vals);

	if(-e $CONF_FILE) {
		@vals = stat $CONF_FILE;
		$fsec = $vals[9];
		if($m_time < $fsec) {
			$error = "Υե뤬Ƥޤ";
			require "admin_02.inc";
			exit;
		}
	} else {
		$fsec = 0;
		if($m_time) {
			$error = "Υե뤬Ƥޤ";
			require "admin_02.inc";
			exit;
		}
	}

	return $fsec;
}

# μ

sub Get_Date
{
	my($time) = @_;

	my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($time);
	$year += 1900;
	$mon += 1;

	return sprintf("%04d/%02d/%02d %02d:%02d:%02d",$year,$mon,$mday,$hour,$min,$sec);
}

# ƥ꡼̾μ

sub Get_Class
{
	my($value,$mark) = @_;

	my(@result) = ();

	foreach (split(",",$value)) {
		push(@result,$LIST_CLASS[$_]);
	}

	return join($mark,@result);
}

# ԽֹΥɽ

sub Print_RecID
{
	my($href,$count,$recmax,$page) = @_;

	my($loop,$max_page,$link,$word);

	$max_page = int($count / $recmax);
	$max_page += 1 if($count % $recmax);

	for($loop = 0;$loop <= $max_page;$loop++) {
		$word = $loop ? "[ ".$loop." ]" : "[ Ͽ ]";
		$link = $href."page=".$loop;
		if($loop != $page) {
			print qq!<A HREF="$link"><FONT COLOR="Blue" SIZE=2><B>$word</B></FONT></A>!;
		} else {
			print qq!<A HREF="$link"><FONT COLOR="Green" SIZE=3><B>$word</B></FONT></A>!;
		}
	}
}

# 饸ܥɽ

sub Print_RadioButton
{
	my($name,$value,@column) = @_;

	my($snum,$loop,$font,@check);

	$snum = $column[0] ? 0 : 1;
	$check[$value] = " CHECKED";

	for($loop = $snum;$loop < scalar(@column);$loop++) {
		$font = qq!<FONT SIZE=2>$column[$loop]</FONT>!;
		print qq!
		<NOBR><INPUT TYPE="radio" NAME="$name" VALUE="$loop"$check[$loop]>$font</NOBR>
		!;
	}
}

# ꥹȥܥåɽ

sub Print_ListBox
{
	my($name,$value,@column) = @_;

	my($loop,@check);

	$check[$value] = " SELECTED";

	print qq!
		<SELECT NAME="$name" SIZE=1>
	!;

	for($loop = 0;$loop < scalar(@column);$loop++) {
		print qq!
			<OPTION VALUE="$loop"$check[$loop]>$column[$loop]
		!;
	}
	print qq!
		</SELECT>
	!;
}

# åܥåɽ

sub Print_CheckBox
{
	my($name,$value,@column) = @_;

	my($loop,$check);

	$value = ",".$value.",";

	for($loop = 1;$loop < scalar(@column);$loop++) {
		$check = "";
		$check = " CHECKED" if($value =~ /,$loop,/);
		print qq!
			<NOBR><INPUT TYPE="checkbox" NAME="$name" VALUE="$loop"$check>
			<FONT SIZE=2>$column[$loop]</FONT></NOBR>
		!;
	}
}

# ƥȥꥢμ

sub Get_TextArea
{
	my($name,$value) = @_;

	my($rows,$lines);

	$lines = scalar(split("\n",$value));

	if($lines < 3) {
		$rows = 3;
	} elsif($lines < 10) {
		$rows = $lines + 2;
	} else {
		$rows = 10;
	}

	return qq!<TEXTAREA COLS=60 ROWS=$rows NAME="$name">\n$value</TEXTAREA>!;
}

# 쥤ȥǡ¸

sub Save_View_Data
{
	my($list,$line,$emark,$flag) = @_;

	my($loop,$key,%items,$found,@values,@result);

	if($line eq '') {
		if($flag) {
			$error = "ϤƤޤ";
			$$emark = qq!<FONT SIZE=2 COLOR="red"><B>[̤ϥ顼]</B></FONT>!;
		}
		return;
	}

	for($loop = 1;$loop < scalar(@{$list});$loop++) {
		$key = ${$list}[$loop];
		$items{$key} = $loop;
	}

	foreach (split("\x0D\x0A|\x0D|\x0A",$line)) {
		@values = ();
		foreach (split(",")) {
			if($items{$_} eq "") {
				$error = "($_)ϿƤޤ";
				$$emark = qq!<FONT SIZE=2 COLOR="red"><B>[̤Ͽ顼]</B></FONT>!;
				return;
			}
			push(@values,$items{$_});
			$found = 1;
		}
		push(@result,join(",",@values)) if(scalar(@values));
	}

	if(!$found) {
		$error = "ϤƤޤ";
		$$emark = qq!<FONT SIZE=2 COLOR="red"><B>[̤ϥ顼]</B></FONT>!;
	}

	return @result;
}

# 쥤ȥǡμ

sub Load_View_Data
{
	my($list,@record) = @_;

	my($loop,@values,@result);

	if(scalar(@record) == 0) {
		for($loop = 1;$loop < scalar(@{$list});$loop++) {
			push(@result,${$list}[$loop].",");
		}
		return join("\n",@result)
	}

	foreach (@record) {
		@values = ();
		foreach (split(",")) {
			push(@values,${$list}[$_]);
		}
		push(@result,join(",",@values));
	}

	return join("\n",@result);
}

# ǡμ

sub Read_Data
{
	my($file) = @_;

	my(@record);

	if(open(IFILE,$file)) {
		while(<IFILE>) {
			chomp();
			push(@record,$_);
		}
		close(IFILE);
	}

	return @record;
}

# ǡ¸

sub Save_Data
{
	my(%values) = @_;

	my($key,$val,@record);

	while(($key,$val) = each(%values)) {
		next if(!$key);
		next if(!${$val}{"CLASS"});

		push(@record,join("\t",$key,${$val}{"CLASS"},${$val}{"CLOSE"},@{${$val}{"VALUE"}}));
	}

	&Save_File($DATA_FILE,0,@record);
}

# եؤ¸

sub Save_File
{
	my($file,$flag,@record) = @_;

	if($SAMPLE_ERROR) {
		$sample = $SAMPLE_ERROR;
		return;
	}

	my($LOCK_FILE) = $file.".lock";

	if(-e $LOCK_FILE) {
		$error = "ߡ̤δԤˤԽƤޤ";
		require "admin_03.inc";
		exit;
	}

	if(!open(OFILE,">$LOCK_FILE")) {
		$error = "ե˽Ǥޤ";
		require "admin_03.inc";
		exit;
	}

	if($flag) {
		print OFILE $copywrite;
		print OFILE "\n\n";
	}

	print OFILE join("\n",@record);
	print OFILE "\n" if($#record >= 0);

	if($flag) {
		print OFILE "\n";
		print OFILE "1;\n\n";
		print OFILE $copywrite;
		print OFILE "\n";
	}

	close(OFILE);

	if($flag) {
		eval do $LOCK_FILE;
		if($@) {
			$error = "ʸ顼ȯޤ";
			require "admin_03.inc";
			exit;
		}
	}

	if(!rename($LOCK_FILE,$file)) {
		$error = "ե¸˼Ԥޤ";
		require "admin_03.inc";
		exit;
	}
	return;
}

# ͤԽ

sub Edit_Value
{
	my($key) = @_;

	my($val) = $$key;

	$val =~ s/\\/\\\\/g;
	$val =~ s/'/\\'/g;

	return '$'.$key.' = '."'".$val."';";
}

# Խ

sub Edit_Array
{
	my($name,@column) = @_;

	my($value,@result);

	foreach $value (@column) {
		$value =~ s/\\/\\\\/g;
		$value =~ s/'/\\'/g;
		push(@result,$value);
	}

	return '@'.$name.' = ('."'".join("','",@result)."');";
}

# ƤԽ

sub Edit_Conf
{
	my(@record,@column,$buff);

	push(@record,&Edit_Value('VAL_TITLE'));
	push(@record,&Edit_Value('VAL_NOTE1'));
	push(@record,&Edit_Value('VAL_NOTE2'));
	push(@record,&Edit_Value('LINK_NAME'));
	push(@record,"");

	push(@record,'$LINK_TYPE = '.int($LINK_TYPE).';');
	push(@record,'$LINK_ITEM = '.int($LINK_ITEM).';');
	push(@record,'$VAL_LINE1 = '.int($VAL_LINE1).';');
	push(@record,'$VAL_LINE2 = '.int($VAL_LINE2).';');
	push(@record,'$VAL_MAXNO = '.int($VAL_MAXNO).';');
	push(@record,'$SORT_ITEM = '.int($SORT_ITEM).';');
	push(@record,'$SORT_TYPE = '.int($SORT_TYPE).';');
	push(@record,'$LAY_ITEM1 = '.int($LAY_ITEM1).';');
	push(@record,'$LAY_ITEM2 = '.int($LAY_ITEM2).';');
	push(@record,'$LAY_NAME1 = '.int($LAY_NAME1).';');
	push(@record,'$LAY_NAME2 = '.int($LAY_NAME2).';');
	push(@record,"");

	push(@record,&Edit_Array('LIST_CLASS',@LIST_CLASS));
	push(@record,&Edit_Array('LIST_ITEMS',@LIST_ITEMS));
	push(@record,&Edit_Array('LIST_INPUT',@LIST_INPUT));
	push(@record,&Edit_Array('LIST_LAY_0',@LIST_LAY_0));
	push(@record,&Edit_Array('LIST_LAY_1',@LIST_LAY_1));
	push(@record,&Edit_Array('LIST_LAY_2',@LIST_LAY_2));
	push(@record,&Edit_Array('LIST_LAY_S',@LIST_LAY_S));
	push(@record,&Edit_Array('LIST_UNITS',@LIST_UNITS));

	push(@record,"");
	push(@record,&Edit_Value('VAL_ENTRY'));
	push(@record,&Edit_Value('VAL_LINKS'));
	push(@record,"");
	push(@record,&Edit_Value('E_A_TITLE'));
	push(@record,&Edit_Value('E_A_NOTES'));
	push(@record,&Edit_Value('E_A_INPUT'));
	push(@record,&Edit_Value('E_A_TEMPL'));
	push(@record,&Edit_Value('E_B_TITLE'));
	push(@record,&Edit_Value('E_B_NOTES'));
	push(@record,&Edit_Value('E_C_TITLE'));
	push(@record,&Edit_Value('E_C_NOTES'));
	push(@record,"");

	push(@record,&Edit_Value('MAIL_PATH'));
	push(@record,&Edit_Value('MAIL_FROM'));
	push(@record,"");

	push(@record,&Edit_Value('M_A_SFLAG'));
	push(@record,&Edit_Value('M_A_EMAIL'));
	push(@record,&Edit_Value('M_A_TITLE'));
	push(@record,&Edit_Value('M_A_HEADS'));
	push(@record,&Edit_Value('M_A_BODYS'));
	push(@record,&Edit_Value('M_A_FOOTS'));
	push(@record,&Edit_Value('M_A_STYPE'));
	push(@record,"");

	push(@record,&Edit_Value('M_U_SFLAG'));
	push(@record,&Edit_Value('M_U_TITLE'));
	push(@record,&Edit_Value('M_U_HEADS'));
	push(@record,&Edit_Value('M_U_BODYS'));
	push(@record,&Edit_Value('M_U_FOOTS'));
	push(@record,&Edit_Value('M_U_STYPE'));

	$buff = &Check_Time($fsec);

	&Save_File($CONF_FILE,1,@record);

	@column = stat $CONF_FILE;
	return $column[9];
}

1;

# Copyright (C) 2007 All right reserved by Shinya Kondo ( CGI KON )
